SystemOrganization addCategory: #'GT-SpotterExtensions-Core'!

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/11/2014 21:21'!
spotterActDefault
	^ PackageTreeNautilus openOnPackage: self! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self definedClasses sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			matchSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/27/2014 22:29'!
spotterExtensionMethodsFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			allCandidates: [ self extensionMethods ];
			title: 'Extension Methods';
			matchSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/7/2014 00:29'!
spotterTagsFor: aStep
	<spotterOrder: 20>
	self classTags size <= 1 ifTrue: [ ^ self ].
	aStep listProcessor
			allCandidates: [ self classTags sorted: [ :a :b | a name < b name ] ];
			title: 'Tags';
			matchSubstring! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/25/2014 13:07'!
spotterActDefault
	^ self browse! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/27/2014 10:48'!
spotterClassInstanceVariablesFor: aStep
	<spotterOrder: 25>
	aStep listProcessor
			title: 'Class instance variables';
			allCandidates: [ self class layout allSlots ];
			itemName: [:each | each name asString];
			matchSubstring! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/27/2014 10:39'!
spotterClassMethodsFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
			title: 'Class methods';
			allCandidates: [ self class methods ];
			itemName: [ :method | method selector ];
			matchSubstring! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterInstanceVariablesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			title: 'Instance variables';
			allCandidates: [ self layout allSlots ];
			itemName: [:each | each name asString];
			matchSubstring! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/27/2014 10:48'!
spotterSubclassesFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'All subclasses';
			allCandidates: [ self allSubclasses ];
			itemIcon: #systemIcon;
			matchSubstring! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 12/9/2014 12:37'!
spotterSuperclassesFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			title: 'All superclasses';
			allCandidates: [ self allSuperclasses ];
			itemIcon: #systemIcon;
			matchSubstring! !

!Class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:04'!
spotterUsedTraitsFor: aStep
	<spotterOrder: 60>
	aStep listProcessor
			title: 'Uses Traits';
			allCandidates: [ self traits asArray ];
			itemIcon: #systemIcon;
			matchSubstring! !

!GTPlayPage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/18/2014 23:00'!
spotterActDefault
	^ GTPlayground new openOn: self! !

!RPackageTag methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 15:54'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self classes sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			matchSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/18/2014 23:22'!
spotterActDefault
	^ self browse! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterForImplementorsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Implementors';
			allCandidates: [ self implementors collect: #compiledMethod ];
			itemName: [ :method | method printString ];
			matchSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterForSendersFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Senders';
			allCandidates: [ self senders collect: #compiledMethod ];
			itemName: [ :method | method printString ];
			matchSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/20/2014 23:13'!
spotterItemsFor: aStep
	"do nothing for compiled method"! !

!Slot methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/1/2014 14:32'!
spotterAccessesFor: aStep
	<spotterOrder: 10>
	(aStep spotter hasPreviousStep and: [
		(aStep spotter previousStep origin isKindOf: Class) or: [
			aStep origin isKindOf: Class]]) ifTrue: [
		aStep listProcessor
				title: 'Accesses';
				allCandidates: [ 
					SystemNavigation default 
						allAccessesTo: self name 
						from: aStep spotter previousStep origin ];
				itemName: [:each | each asString];
				matchSubstring ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/5/2014 00:02'!
spotterAllRepositoriesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
		title: 'All other repositories';
		allCandidates: [ MCRepositoryGroup default repositories \ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item | self spotterCommit: self in: item ];
		matchSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/3/2014 07:34'!
spotterCommit: workingCopy in: aRepository
	| newVersion |

	newVersion := workingCopy newVersionIn: aRepository.
	newVersion ifNil: [ ^ self ].
	Cursor wait showWhile: [
		[ 	aRepository storeVersion: newVersion.
			aRepository storeDependencies: newVersion ] 
		ensure: [ (MCVersionInspector new version: newVersion) show ]]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/4/2014 22:10'!
spotterPackageRepositoriesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
		title: 'Package repositories';
		allCandidates: [ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item | self spotterCommit: self in: item ];
		matchSubstring! !

!Trait methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 15:55'!
spotterActDefault
	^ self browse! !

!Trait methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:27'!
spotterClassMethodsFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
			title: 'Class methods';
			allCandidates: [ self classTrait methods ];
			itemName: [ :method | method selector ];
			matchSubstring! !

!Trait methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:27'!
spotterCompositionFor: aStep
	<spotterOrder: 25>
	aStep listProcessor
			title: 'Composing traits';
			allCandidates: [ self traitComposition allTraits ];
			itemIcon: #systemIcon;
			matchSubstring! !

!Trait methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:27'!
spotterTraitUsersFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			title: 'Users';
			allCandidates: [ self traitUsers asArray ];
			itemIcon: #systemIcon;
			matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/18/2015 21:12'!
filterByQuery: originalQuery forReferencesComputedAs: fileReferencesBlock inProcessor: processor onStream: stream
	| prefixMatchers split rootDirectory query fullQuery rest |
	fullQuery := originalQuery trimBoth asLowercase.
	split := fullQuery piecesCutWhere: [ :a :b | a = FileSystem disk delimiter ].
	split size <= 1
		ifTrue: [ 
			query := fullQuery.
			rootDirectory := FileSystem workingDirectory ]
		ifFalse: [ 
			(split last last = FileSystem disk delimiter)
				ifTrue: [ 
					query := ''.
					rootDirectory := fullQuery asFileReference ]
				ifFalse: [ 
					query := split last.
					rootDirectory := ('' join: split allButLast) asFileReference ] ].
	rootDirectory exists ifFalse: [ ^ OrderedCollection new ].
	query isEmpty ifTrue: [ 
		| all |
		all := fileReferencesBlock value: rootDirectory.
		(all first: (all size min: 5)) do: [:reference | stream addObject: reference inProcessor: processor].
		^ all  ].
	prefixMatchers := OrderedCollection new.
	rest := OrderedCollection new.
	(fileReferencesBlock value: rootDirectory) do: [ :reference | 
			| index |
			index := reference basename findString: query startingAt: 1 caseSensitive: false.
			index >= 1 ifTrue: [ 
				index = 1 
					ifTrue: [ 
						prefixMatchers add: reference.
						prefixMatchers size > 5
							ifFalse: [ stream addObject: reference inProcessor: processor ] ]
					ifFalse: [ rest add: reference ] ] ].
	prefixMatchers size < 5
		ifTrue: [ (rest first: (5 - prefixMatchers size min: rest size)) do: [ :each | stream addObject: each inProcessor: processor ] ].
	^ prefixMatchers , rest! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/5/2014 07:08'!
spotterDirtyMonticelloPackagesFor: aStep
	<spotterOrder: 85>
	aStep listProcessor
			allCandidates: [ MCWorkingCopy allManagers select: #modified ];
			title: 'Dirty Monticello packages';
			itemIcon: [ Smalltalk ui icons iconNamed: #dirtyPackageIcon ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/11/2014 21:18'!
spotterForClassesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			allCandidates: [ Smalltalk allClassesAndTraits ];
			title: 'Classes';
			matchSubstring;
			itemIcon: #systemIcon;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/17/2014 11:24'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 50>
	| processor |
	processor := aStep listProcessor.
	processor
		title: 'Directories';
		wantsToDisplayOnEmptyQuery: false;
		filter: [ :originalQuery :stream | 
					self
						filterByQuery: originalQuery
						forReferencesComputedAs: [ :root | root directories ]
						inProcessor: processor
						onStream: stream ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/17/2014 11:24'!
spotterForFilesFor: aStep
	<spotterOrder: 40>
	| processor |
	processor := aStep listProcessor.
	processor
		title: 'Files';
		wantsToDisplayOnEmptyQuery: false;
		filter: [ :originalQuery :stream | 
					self
						filterByQuery: originalQuery
						forReferencesComputedAs: [ :root | root files ]
						inProcessor: processor
						onStream: stream ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:35'!
spotterForGlobalVarsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			allCandidates: [ Smalltalk globals associations select:[:assoc | 
			assoc value isBehavior not and:[ 
				assoc value isTrait not]] ];
			title: 'Global variables';
			itemName:[:global | global key ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterForPackagesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ RPackageOrganizer default packages ];
			title: 'Packages';
			itemName: [ :package | package name ];
			itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterForPlaygroundPagesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
			allCandidates: [ GTPlayBook instance pages ];
			title: 'Playground';
			itemName: [ :page | page content asString contractTo: 100 ];
			matchSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/14/2015 19:26'!
spotterForPragmasFor: aStep
	<spotterOrder: 40>
	aStep listProcessor 
			allCandidates: [:x | PragmaType all ];
			title: 'Pragmas';
			itemName: [ :pragma | pragma keyword ];
			matchSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/5/2014 07:07'!
spotterHistoryFor: aStep
	<spotterOrder: 80>
	aStep listProcessor
			allCandidates: [:x | self class history select: [ :each | each isNotNil ] ];
			title: 'History';
			matchSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/11/2014 07:27'!
spotterImplementorsFor: aStep
    <spotterOrder: 30>
	| processor |
	self flag: 'This has to be refactored from scratch'.
	processor := aStep listProcessor.
	processor
		title: 'Implementors';
		filter: [ :originalQuery :stream |
			|query prefixMatchers rest |
			query := originalQuery trimBoth asLowercase.
			query isEmpty 
				ifFalse: [
					prefixMatchers := OrderedCollection new.
					rest := OrderedCollection new.
					SystemNavigation default allBehaviorsDo: [:class | 
						class selectorsDo:[ :selector | 
							| index |
							index := (selector findString: query startingAt: 1 caseSensitive: false).
							index >= 1 ifTrue: [
								| method |
								method := class>>selector.
								index = 1 ifTrue: [ 
									prefixMatchers add: method.
									prefixMatchers size > 5 ifFalse: [ 
										stream addObject: method inProcessor: processor ]]
									ifFalse: [ rest add: method ]]]].
					(prefixMatchers size < 5) ifTrue: [ 
						(rest first: ((5 - prefixMatchers size) min: rest size)) do: [ :each |
							stream addObject: each inProcessor: processor ] ].
					prefixMatchers , rest ]  ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/5/2014 06:23'!
spotterStfxFor: aStep
	<spotterOrder: 30>
	| processor |
	processor := aStep listProcessor.
	processor 
		title: 'ws.stfx.eu';
		filter: [ :originalQuery :stream |
			| aCollection query |
			aCollection := OrderedCollection  new.
			query := originalQuery trimBoth.
			(query beginsWith: 'http://ws.stfx.eu') ifTrue: [ 
				[| string page |
				string := GTUrlProvider new get: query.
				page := GTPlayPage new content: string.
				stream addObject: page inProcessor: processor.
				aCollection add: page] on: Error do: [ "nothing" ] ].
			aCollection ].
	^ processor! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/17/2014 12:56'!
spotterWorldMenuFor: aStep
	<spotterOrder: 9>
	^ (World worldMenu spotterItemsFor: aStep)
		title: 'Menu'! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/22/2014 17:33'!
allItems
	| all |
	all := OrderedCollection new.
	self items do: [ :each |
		all add: each.
		each hasSubMenu 
			ifTrue: [ all addAll: each subMenu allItems ] ].
	^ all! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:24'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor 
		title: 'Items';
		candidatesLimit: Float infinity;
		allCandidates: [ self items ];
		itemName: #contents;
		itemIcon: [ :item | item icon ];
		actLogic: [ :item | item hasSubMenu 
					ifTrue: [ aStep diveIn ] 
					ifFalse: [ item spotterActDefault. aStep exit ] ];
		matchSubstring ! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/15/2014 00:01'!
spotterActDefault
    ^ self method browse! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:11'!
spotterMethodsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Instance methods';
			allCandidates: [ self methods ];
			itemName: [ :method | method selector ];
			matchSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:13'!
spotterReferenceFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self binding) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			matchSubstring! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:35'!
spotterActDefault
	self value inspect! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:36'!
spotterClassFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'Class';
			allCandidates: [ { self value class }];
			itemIcon: #systemIcon;
			matchSubstring! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:36'!
spotterReferenceFor: aStep
	<spotterOrder: 130>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			matchSubstring! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/21/2014 11:13'!
spotterActDefault
	self doButtonAction! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 12:21'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	self hasSubMenu ifTrue: [ 
		self subMenu spotterItemsFor: aStep ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 10>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self directories ];
			title: 'Directories';
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
			matchSubstring ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterForFilesFor: aStep
	<spotterOrder: 20>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self files ];
			title: 'Files';
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			matchSubstring ]! !

!Collection methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 12/20/2014 19:07'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor
		title: 'Items';
		candidatesLimit: 100;
		allCandidates: [ OrderedCollection newFrom: (self collect: [ :each | each copy ])];
		itemName: [ :each | each renderingProcessor itemNameFor: each value ];
		matchSubstring;
		wantsToDisplayOnEmptyQuery: true! !

Object subclass: #PragmaType
	instanceVariableNames: 'keyword pragmas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!PragmaType commentStamp: 'TudorGirba 11/16/2014 12:57' prior: 0!
This models the type of pragma instances.

It essentially knows the keyword that defines the Pragma, and can obtain all occurences of that Pragma.

!!!!Example

[[[
	PragmaType all
]]]!

!PragmaType class methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
all
	| pragmas |
	pragmas := OrderedCollection new.
	Object withAllSubclassesDo: [:each |
		Pragma withPragmasIn: each do: [:p |
			pragmas add: p]].
	^ (pragmas groupedBy: #keyword) associations collect: [ :association |
		PragmaType new
			keyword: association key; 
			pragmas: association value ] ! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:54'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Pragmas';
		display: [ self pragmas ];
		format: #gtDisplayString! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword
	^ keyword! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword: anObject
	keyword := anObject! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:58'!
pragmas
	^ pragmas ifNil: [
		pragmas := OrderedCollection new.
		Object withAllSubclassesDo: [ :each |
			Pragma withPragmasIn: each do: [ :p |
				p keyword = self keyword ifTrue: [ 
					pragmas add: p ] ] ].
		pragmas ]! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
pragmas: aCollection
	pragmas := aCollection! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:53'!
printOn: stream
	stream nextPutAll: self keyword! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/26/2014 14:25'!
spotterPragmasFor: aStep
	<spotterOrder: 40>
	^ aStep listProcessor
		title: 'Pragmas';
		allCandidates: [ self pragmas ];
		itemName: [ :pragma | pragma method printString , ' ' , pragma asString ];
		matchSubstring! !
